/* yasep/VHDL/config.js
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
2009-05-28 : yasep/tools/generate_VHDL.html created by whygee at f-cpu.org from opcode_map.html
2009-06-06
2009-07-11
2009-07-28 : Y
20090830 : config panel
20090920 : SULV->SLV
dim. févr. 12 06:49:50 CET 2012 : windowed version
dim. févr. 19 09:32:45 CET 2012 : adding valid instructions and such (should be generalised with "profiles")
lun. févr. 20 12:14:17 CET 2012 : profiles almost working
jeu. mai  10 05:17:49 CEST 2012 : moved to VHDL
lun. juil. 29 08:21:49 CEST 2013 : trying to rebuild, as cleanup looks too hard

Purpose : Makes buttons that configure a profile and export the corresponding VHDL definitions

Quite buggy, i'm rebuilding it...
 */

init_obj.push(config={
  win: null,
  opcodes_id:[],
  mul_id:[],
  cond_id:[],
  size_id:[],
  empty:false,
  multable:{
    "MUL8L":8,
    "MUL8H":8,
    "MULI":8,
    "LUT8":8,
    "MUL16H":16,
    "MUL16L":16},

  changeInstruction: function(val,n,force) { // n:string (instruction name)
    if (typeof config.core!="object")
      wa("VHDL/config#name=empty");

    // change only if different
    if ((force===true) || (val != config.opcodes_id[n].checked)) {
      var c=config.core, t;

      // Force some values if we're in "auto-collection" mode
      if((val===true) && config.empty) {
        if((c.datapath!=32) && config.Y32_id[n]){
          config.core.datapath=32;
          config.win.shortmsg("force datapath=32");
        }
        if ((t=config.multable[n]) && (t>c.multiplier)){
          config.core.multiplier=t;
          config.win.shortmsg("force multiplier="+t);
        }
      }
      c.valid_instructions[n]=(val===true)? 1 : 0;
      config.opcodes_id[n].checked=val;
      delay(config.delay_check);
    }
  },

  changeBox: function() {
    config.changeInstruction(this.checked, this.id, true);
  },
 
// check the configuration sanity
// Warning !! potential crazy loop because changeInstruction
// delay-calls check which calls changeInstruction...
  check: function() {
    var n, c=config.core;

    switch (c.multiplier) {
      case 0:
      case 8: // just filters the valid values.
      case 16: break;
      default : c.multiplier=0;
    }

    if (c.datapath!=32)
        c.datapath =16;

    config.size_id[c.datapath].checked=true;
    switch (c.datapath) {
      case 16: if (c.multiplier==16)
                   c.multiplier =8; // constrain the MUL size
               // disable all the Y32only
               for (n in config.Y32_id)
                 config.changeInstruction(false,n);
               // enable the Y16
               break;
      case 32: // disable all the Y16only
               // enable the Y32
               break;
    }

    config.cond_id[c.CondR1].checked=true;
    config.mul_id[c.multiplier].checked=true;
    for (n in config.multable)
      if (config.multable[n] > c.multiplier)
        config.changeInstruction(false,n);

    if (c.PC_length<3)
        c.PC_length=3;
    if (c.PC_length>c.datapath)
        c.PC_length=c.datapath;
    config.PCwidth_id.innerHTML
   =config.PCwidth_id.source
   =c.PC_length;
  },

//////////////////////// generate the file ////////////////////////
  emit_VHDL: function(){
    config.check();

    var line, col, cvi, c=config.core,
      f, i, n, t, j, index, instr, vhdl=generated("--","VHDL/config.js")
+'-- Profile name : '+config.name_id.innerHTML+'\n'
+'\n'
+'Library ieee;\n'
+'    use ieee.std_logic_1164.all;\n'
+'    use ieee.numeric_std.all;\n'
+'\n'
+'package yasep_definitions is\n'
+'----------------------------------------------------------\n'
+'-- user defined values :\n'
+'  constant YASEP_SIZE : natural := '+c.datapath+';\n'
+'  constant YASEP_MUL  : natural := '+c.multiplier+';\n'
//+'constant PIPELINED  : natural := '+config.core.pipelined+';\n'
+'  constant Enable_CondR1 : natural := '+c.CondR1+';\n'
+'  constant PC_LENGTH  : natural := ',
        valid_instructions=[],
        noWriteBack=[],
        noCondition=[],
        IMM_5LSB=[],
        abortWrite=[],
        IgnoreSND=[],
        IgnoreSI4=[],
        IgnoreImm16=[],
        ChangeCarry=[],
        Imm20=[],
        ChangeZero=[];

    if (typeof c.PC_length =="number")
      vhdl+=c.PC_length;
    else
      vhdl+='YASEP_SIZE';

    vhdl+=';\n\n'
+'----------------------------------------------------------\n'
+'-- exported from the JavaScript definitions :\n\n'
+'  subtype SLV2   is std_logic_vector( 1 downto 0);\n'
+'  subtype SLV3   is std_logic_vector( 2 downto 0);\n'
+'  subtype SLV4   is std_logic_vector( 3 downto 0);\n'
+'  subtype SLV5   is std_logic_vector( 4 downto 0);\n'
+'  subtype SLV6   is std_logic_vector( 5 downto 0);\n'
+'  subtype SLV8   is std_logic_vector( 7 downto 0);\n'
+'  subtype SLV16  is std_logic_vector(15 downto 0);\n'
+'  subtype SLV32  is std_logic_vector(31 downto 0);\n'
+'  subtype SLVr64 is std_logic_vector(0 to 63);\n'
+'  subtype SLVY   is std_logic_vector(YASEP_SIZE-1 downto 0);\n'
+'  subtype SLVAI  is std_logic_vector(PC_LENGTH-1 downto 1);\n\n';

    for (i=0; i<16; i++) {
      t=Y.registers_names[i];
      vhdl+='  constant REG_'+pad_right(t,4)
          + ': SLV4 := "'+toBin(i,4)+'";\n';
    }
    vhdl+='\n';

    for (line=0; line<32; line+=4) { // group number
      t=Y.GroupNames[line];
      if (typeof t=="string") {
        vhdl+="  constant "+t;
        i=t.length; while (i<10) { i++; vhdl+=' '; }
        vhdl+=' : SLV3 :=    "'+toBin(line>>2,3)+'";\n';
      }
      for (col=0; col<8; col++) {
        index=line|(col<<5);
        instr=Y.opcode_table[index];
        if (typeof instr == 'object') {
          n=instr.name;
          i=index>>2;
          f=instr.flags;
          if (c.valid_instructions[n]===1) {
            valid_instructions[i]=1;
            if(f & Y.NO_WRITEBACK) noWriteBack[i]=1;
            if(f & Y.NO_CONDITION) noCondition[i]=1;
            if(f & Y.IMM16_5LSB)   IMM_5LSB[i]=1;
            if(f & Y.ABORT_WRITE)  abortWrite[i]=1;
            if(f & Y.IGNORE_SND)   IgnoreSND[i]=1;
            if(f & Y.IGNORE_SI4)   IgnoreSI4[i]=1;
            if(f & Y.IGNORE_IMM16) IgnoreImm16[i]=1;
            if(f & Y.CHANGE_CARRY) ChangeCarry[i]=1;
            if(f & Y.CHANGE_ZERO)  ChangeZero[i]=1;
            if((f & Y.IMM20) && (config.core.datapath==32)) 
                                   Imm20[i]=1;
          }

          vhdl+='  constant Op_'+n;
          f=n.length; while (f<7) { f++; vhdl+=' '; }
          vhdl+=' : SLV6 := "'+toBin(i,6)+'";'
               +'  constant F_'+n;
          f=n.length; while (f<6) { f++; vhdl+=' '; }
          vhdl+=' : SLV3 := "'+toBin(i>>3,3)+'";';
          if (c.valid_instructions[n]!==1)
            vhdl+=' -- disabled' ;
          vhdl+='\n';
        }
      }
      vhdl+='\n';
    }

    vhdl+='\n-- Flags :\n'
+    '  constant FlagValidInstruction : SLVr64 := "'+(cvi=collapse(valid_instructions))
// Export the valid_instructions field in hexa, for incorporating
// later in the profiles collection of core-js/yasep_profiles.js:
+'";\n-- Compacted mask: '+encodeInstructionMask(cvi)
+ ';\n  constant FlagNoWriteBack      : SLVr64 := "'+collapse(noWriteBack)
+'";\n  constant FlagNoCondition      : SLVr64 := "'+collapse(noCondition)
+'";\n  constant FlagIMM16_5LSB       : SLVr64 := "'+collapse(IMM_5LSB)
+'";\n  constant FlagAbortWrite       : SLVr64 := "'+collapse(abortWrite)
+'";\n  constant FlagIgnoreSND        : SLVr64 := "'+collapse(IgnoreSND)
+'";\n  constant FlagIgnoreSI4        : SLVr64 := "'+collapse(IgnoreSI4)
+'";\n  constant FlagIgnoreImm16      : SLVr64 := "'+collapse(IgnoreImm16)
+'";\n  constant FlagChangeCarry      : SLVr64 := "'+collapse(ChangeCarry)
+'";\n  constant FlagChangeZero       : SLVr64 := "'+collapse(ChangeZero)
+'";\n  constant FlagImm20            : SLVr64 := "'+collapse(Imm20)
+'";\n'
+'end yasep_definitions;\n'
+'\n'
+'package body yasep_definitions is\n'
+'  -- empty\n'
+'end yasep_definitions;\n';

    savefile.save("yasep_def.vhdl", vhdl);
  },

////////////////////////////////////////////////////////////////////////

  changeRadio: function() {
    config.trigger(this.name+"="+this.value);
  }, // yeah, it's a compact trick, but a simple one :-)

  trigger: function(s) {
    if (s=="")
      return;

    if (s=="emitVHDL")
      return config.emit_VHDL();

    var i,j=0,u,v;

    s=s.split(',');

    for (i in s){
      u=s[i].split("=");
      if (u.length==2) {
        v=u[0];
        if (v=="name") {
          if (j) // !=0
            return alert("Malformed configuration request: the profile name must be the first parameter");
          else
            config.change_profile(u[1]);
        }
        else
          if (typeof config.core[v]=="number")
                     config.core[v]=+u[1];
        j++;
        config.check();
      }
      else
        return alert("Malformed configuration request : missing argument ?");
    }
  },

  AddProfile: function() {
//    config.nameInput_id.style.display="none";
  },

  change_profile: function(a) {
    if (typeof profiles[a] != "object")
      return Al8N("Ipn");
    config.name_id.innerHTML=a;
    config.empty=(a=="empty");
    config.block_id.style.display="block";
    var n, p=profiles[a];
    config.core={
      multiplier:p.multiplier,
      PC_length:p.PC_length,
      valid_instructions:[], // p.valid_instructions, => updated in changeInstruction
      datapath:p.datapath,
      CondR1:p.CondR1
    };

    for (n in config.opcodes_id)
      config.changeInstruction( p.valid_instructions[n]===1, n, true);
  },

  list_profiles: function(){
    var l=config.list_div, p, d=dcE("div"), m="<table>";
    while (l.firstChild)
        rC(l.firstChild);
    for (p in profiles)
      m+='<tr><td class="fr"><button onclick="wa(\'VHDL/config#name='+p+'\')">'+p+"</button></td><td>"+profiles[p].comment+"<br>&nbsp;</td></tr>";
    d.innerHTML=m+"</table>";
    l.appendChild(d);
  },

  start: function() {
    var cont=dcE("DIV");
    cont.innerHTML=import_htmi("VHDL/config");
    winman.patchInnerLinks(cont);
    var opcodes_id, h=getByClass("hiddenDiv","DIV",cont),
    w= ygwm.new_window(
       hiddenText(0,h), null, cont,
       500, 500, 40, 40, false, true, true, true, false, "WinOK");

    config.delay_check={
      delay: 200, // 0.2s
      func: config.check
    };

    toggle( // hide until the user imports a profile
       config.block_id=getById("profConfig","div",cont));
    getById("save_V","button",config.cont).onclick=config.emit_VHDL;
     (config.mul_id[0]  =getById("mul0"  ,"input",cont)).onclick
    =(config.mul_id[8]  =getById("mul8"  ,"input",cont)).onclick
    =(config.mul_id[16] =getById("mul16" ,"input",cont)).onclick
    =(config.size_id[16]=getById("size16","input",cont)).onclick
    =(config.size_id[32]=getById("size32","input",cont)).onclick
    =(config.cond_id[0] =getById("bit0"  ,"input",cont)).onclick
    =(config.cond_id[1] =getById("bit1"  ,"input",cont)).onclick
    = config.changeRadio;

    config.list_div=getById("profiles_list","div",cont);
    config.name_id=getById("profName","tt",cont);

    edit_text.register(
      (config.PCwidth_id=getById("PCwidth","span",cont)), {
        size:4, maxsize:4,
        defaultValue: "16",
        bg:true,
        func: function(){
          var t=this;
          edit_text.filter_number(t);
          config.core.PC_length = +t.value;
        },
        check: function(t){
          edit_text.filter_number(t);
          t=+t.value;
          edit_text.valid=((t>=3)&&(t<=config.core.datapath));
        }
      });

    edit_text.register(
      (config.addButton_id=getById("add","button",cont)), {
        size:16, maxsize:20,
        defaultValue:hiddenText(1,h),
        func:function(){
          w.shortmsg(this.value);
        }
/*
        check: function(t){
          w.shortmsg("plop");
          edit_text.filter_alpha(t);
          edit_text.valid= (typeof profiles[t]!= "object")
        }
*/
      }
    );
/*
    getById("add","button",cont).onclick=function() {
      toggle(config.nameInput_id);
      config.nameInput_id.focus();
    };
*/

toggle(config.addButton_id);  // hide the "save" for now


    config.Y32_id=[];
    config.opcodes_id=[];

    var cb, col, line, instr, sp, tr,td, n,
      tab=config.optable_id=getById("sel_opcodes","table",cont);
    for (line=0; line<32; line+=4) { // group number
      tr=dcE("TR");
        (td=dcE("TD")).innerHTML=Y.GroupNames[line].slice(6)+":&nbsp;";
        td.className="fr";
      tr.appendChild(td);
      for (col=0; col<256; col+=32) {
        if(instr=Y.opcode_table[line+col]) {
          n=instr.name;
          (td=dcE("TD")).className="miniInstr";
            ( cb
             =config.opcodes_id[n]
             =dcE("input")).type="checkbox";
             if (instr.flags & Y.YASEP32_ONLY)
               config.Y32_id[n]=1;
             cb.id=n;
             cb.onchange=config.changeBox;
            td.appendChild(cb);
            (sp=dcE("span")).innerHTML=n;
            td.appendChild(sp);
          tr.appendChild(td);
        }
      }
      tab.appendChild(tr);
    }

    config.list_profiles();
    adjustHeight(config.list_div);

    w.eraseCallback=function(){
      clearTimeout(config.delay_check.timer);
      config.core=null; // force the re-opening of the window next time an instruction is parsed in ".auto" mode
      delete config.core;
    };
    w.trigger=config.trigger;
    return (config.win=w);
  },

  init_obj: function(){
    config.menuItem = menu.subMenuItem(menu.list["Tools"],i8n.cc, "VHDL/config");
  }
});
