-- test_fb.vhdl
-- created mar. févr. 21 14:26:03 CET 2012 by whygee@f-cpu.org
-- version mar. mars 20 17:57:34 CET 2012 : reboot
-- version mer. nov. 21 22:26:12 CET 2012 : framebuffer

Library ieee;
    use ieee.std_logic_1164.all;
    use ieee.numeric_std.all;
library work;
    use work.fb_ghdl.all;
    use work.yasep_definitions.all;
    use work.yasep_utils.all;

entity test_fb is
end test_fb;

architecture toplevel of test_fb is
  signal WR_en  : std_logic := '0';
  signal WB_en  : std_logic := '0';
  signal phase  : std_logic := '0';
  signal ProgRdEn : std_logic := '1';
  signal clk    : std_logic := '0';
  signal reset  : std_logic := '0';
  signal CARRY  : std_logic := '0';
  signal FlagZero : std_logic := '0';
  signal condR1 : integer := 45;
  signal condition  : std_logic := '0';
  signal Condition2  : std_logic := '0';
  signal Field_cond, Field_SI4, Field_SND : SLV4 := "0000";

  signal PC : SLVAI := (SLVAI'range => '0');
  signal NPC : SLVAI := (SLVAI'range => '0');
  signal RAM_out : SLV16 := (SLV16'range => '0');
  signal DST : SLV4 := "0000";

  signal GetReadPort, PutWritePort, SRaddress: SLVY := (SLVY'range => '0');
--  signal GET_en  : std_logic := '0';
--  signal PUT_en  : std_logic := '0';
  signal INV  : std_logic := '0';

  signal A1_en : std_logic := '0';
  signal R1, R2, R3, R4, R5,
         A1, A2, A3, A4, A5,
         D1, D2, D3, D4, D5, Result: SLVY := (SLVY'range => '0');
  signal x1, x2, x3, x4, x5,
         y1, y2, y3, y4, y5 : integer := 0;

begin
  ProgRAM:
    entity work.SynchRam16
    port map(
      clk => clk,
      reset => reset,
      en => ProgRdEn,
      NPC => NPC,
      RAM_out => RAM_out);

  uY:
    entity work.microYASEP
    port map(
      ExecPrediv => "0000",
      NPC => NPC,
      PC => PC,
      RAM_out => RAM_out,
      ProgRdEn=>ProgRdEn,
      DST => DST,
      phase => phase,
      WB_en => WB_en,
      WR_en => WR_en,
      Carry => CARRY,
      FlagZero => FlagZero,
      Condition2 => Condition2,
      Condition  => Condition,
      Field_cond => Field_cond,
      Field_SI4  => Field_SI4,
      Field_SND  => Field_SND,
      R1 => R1,   R2 => R2,   R3 => R3,   R4 => R4,   R5 => R5,
      A1 => A1,   A2 => A2,   A3 => A3,   A4 => A4,   A5 => A5,
      D1 => D1,   D2 => D2,   D3 => D3,   D4 => D4,   D5 => D5,
      INV => INV,
      GetReadPort => GetReadPort,
      PutWritePort =>  open,
      SRaddress => open,
      GET_en => open,
      PUT_en => open,

      Result => Result,

      clk => clk,
      reset => reset);

-- the external "register set"
  process (clk, reset)
    variable x, y, i : integer;
    variable c: SLVY;
  begin
    if reset='0' then
      D1 <= (R1'range => '0');
      D2 <= (R1'range => '0');
      D3 <= (R1'range => '0');
      D4 <= (R1'range => '0');
      D5 <= (R1'range => '0');
    else
      if rising_edge(clk) and WR_en = '1' then

        -- prepare the common data :
        case DST is
          when REG_A1 | REG_A2 | REG_A3 | REG_A4 | REG_A5 =>
            y := to_integer(signed(Result)); -- check the address range
            if (y >= 131072) and (y <= 393215) then
              y := 100 +  to_integer(unsigned(Result(31 downto 10))) -128;
              x := 700 +  to_integer(unsigned(Result( 9 downto  2)));
              c := std_logic_vector( to_unsigned( pixel(y,x) ,32));
            end if;
          when REG_R1 | REG_R2 | REG_R3 | REG_R4 | REG_R5 =>
              i := to_integer(signed(result));
          when others => -- nothing
        end case;

        -- apply these data to the right places
        case DST is
          when REG_D1 => D1 <= Result; pixel(y1,x1):=i;
          when REG_D2 => D2 <= Result; pixel(y2,x2):=i;
          when REG_D3 => D3 <= Result; pixel(y3,x3):=i;
          when REG_D4 => D4 <= Result; pixel(y4,x4):=i;
          when REG_D5 => D5 <= Result; pixel(y5,x5):=i;

          when REG_A1 => D1 <= c; x1<=x ; y1<=y;
          when REG_A2 => D2 <= c; x2<=x ; y2<=y;
          when REG_A3 => D3 <= c; x3<=x ; y3<=y;
          when REG_A4 => D4 <= c; x4<=x ; y4<=y;
          when REG_A5 => D5 <= c; x5<=x ; y5<=y;
          when others => -- nothing
        end case;
      end if;
    end if;
  end process;

--  observe: process(clk)
--    variable i, j: integer;
--  begin
--    if clk='0' and phase='1' then
--      report " " -- "phase="     & std_logic'image(phase)
--           & " WR_en="     & std_logic'image(WR_en)
--           & " CARRY="     & std_logic'image(CARRY)
--           & " Rd="        & std_logic'image(ProgRdEn)
--           & " EQ="        & std_logic'image(FlagZero)
--           & " cond="     & std_logic'image(condition)
--           & " cond2="     & std_logic'image(Condition2)
--           & " cR1="     & integer'image(condR1)
--           & " Fcond="     & SLV_to_Hex(Field_cond)
--           & " WB_en="     & std_logic'image(WB_en)
--           & " GET_en="    & std_logic'image(GET_en)
--           & " PUT_en="    & std_logic'image(PUT_en)
--           & " A1_en="     & std_logic'image(A1_en)
--         & "   PC="        & SLV_to_Hex(PC & '0')
--          & "  NPC="       & SLV_to_Hex(NPC & '0')
--          & "  RAM_out="   & SLV_to_Hex(RAM_out)
--          & "  Result="    & SLV_to_Hex(Result)
--          & " DST="       & SLV4_to_Hex(DST)
--          & " R1="        & SLV_to_Hex(R1)
--          & " R2="        & SLV_to_Hex(R2)
--          & " R3="        & SLV_to_Hex(R3)
--          & " A1="        & SLV_to_Hex(A1)
--          & " A2="        & SLV_to_Hex(A2)
--          & "  SRaddress=" & SLV_to_Hex(SRaddress)
--          & "  D1="        & SLV_to_Hex(D1)
--         & " "         & integer'image(safe_to_integer())
--      ;
--    end if;
--  end process;


  bench: process
    variable i: integer := 0;
  begin
                wait for 1 us;
    clk <= '1'; wait for 1 us;
    clk <= '0'; wait for 1 us;

    report " *** releasing reset *** ";
    reset <= '1'; wait for 1 us;

    while i < 1000000 loop
      clk <= '1'; wait for 1 us;
      clk <= '0'; wait for 1 us;
      i:=i+1;
      if INV='1' then
        if (R5="0110000000001101")
         or RAM_out(R_OPCODE'range) = Op_HALT then -- GOOD ?
          report "Simulation succeeded";
        else
          if (R5="1101111010101101") then -- DEADh ?
            report "Simulation failed : testbench error at " & SLV_to_Hex(R4) & "h";
          else
            report "Simulation stopped : Invalid instruction";
          end if;
        end if;
        wait;
      end if;
    end loop;
    report "### stopping after " & integer'image(i) & " cycles";
    wait;
  end process;

end toplevel;
