/* file yasep/core-js/group_mul.js
This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
created 2009-05-26 by whygee@f-cpu.org from group_mul.js
2009-07-28 : added Y
2009-07-29 : FORM_iR
2009-07-29 : FORM_iR
2009-08-04 : NO_WRITEBACK
2009-08-14 : MULI
2009-08-15 : IgnoreImmSign
2011-09-20 : NO_CONDITION to MULI
2011-11-27 : CRC
2012-09-20 : CRC->LUT8

This file implements the "MUL" (multiply) Execution Unit
 (and a table-based CRC)
dependency : group_eu.js and all its parents
*/

Y.prefix=Y.GROUP_MUL;

Y.NewOpcode("MUL8L",
 function(s) {
   var sa= s.snd & F2,
       sb= s.si4 & F2;
   s.result = sa * sb;
 },
 function(s) {
   var sa= s.snd & F2,
       sb= s.si4 & F2;
   s.result = sa * sb;
 },
 Y.FORM_RR | Y.FORM_IRR | Y.FORM_iR | Y.FORM_IR | Y.FORM_iRR | Y.FORM_RRR,
 Y.OPTIONAL|Y.ALIAS_IRR|Y.IMM16_8LSB|Y.IgnoreImmSign,
 "Multiply lower byte (unsigned)");

Y.NewOpcode("MUL8H",
 function(s) {
   var sa=  s.si4       & F2,
       sb= (s.snd >> 8) & F2;
   s.result = sa * sb;
 },
 function(s) {
   var sa=  s.si4       & F2,
       sb= (s.snd >> 8) & F2;
   s.result = sa * sb;
 },
 Y.FORM_RR | Y.FORM_IRR | Y.FORM_iR | Y.FORM_IR | Y.FORM_iRR | Y.FORM_RRR,
 Y.OPTIONAL|Y.ALIAS_IRR|Y.IMM16_8LSB|Y.IgnoreImmSign,
 "Multiply higher byte (unsigned)");

Y.NewOpcode("MULI",
 null, null,
 Y.FORM_RR | Y.FORM_IR | Y.FORM_iR,
 Y.NO_CONDITION|Y.OPTIONAL|Y.NO_WRITEBACK|Y.IgnoreImmSign,
 "Initialize one multiply LUT entry");

Y.NewOpcode("LUT8",
 null, null,
 Y.FORM_RR | Y.FORM_IRR | Y.FORM_iR | Y.FORM_IR | Y.FORM_iRR | Y.FORM_RRR,
 Y.Preliminary|Y.ALIAS_IRR|Y.IMM16_8LSB|Y.IgnoreImmSign,
 "XOR source register with LookUp Table's contents (1 byte in, 2 or 4 bytes out)");

Y.NewOpcode("MUL16L",
 function(s) {
   var sa= s.snd & F4,
       sb= s.si4 & F4;
   s.result = sa * sb;
 },
 null,
 Y.FORM_RR | Y.FORM_IRR | Y.FORM_iR | Y.FORM_IR | Y.FORM_iRR | Y.FORM_RRR,
 Y.OPTIONAL|Y.ALIAS_IRR|Y.IgnoreImmSign|Y.YASEP32_ONLY,
 "Multiply lower halfword (unsigned)");

Y.NewOpcode("MUL16H",
 function(s) {
   var sa=  s.si4        & F4,
       sb= (s.snd >> 16) & F4;
   s.result = sa * sb;
 },
 null,
 Y.FORM_RR | Y.FORM_IRR | Y.FORM_iR | Y.FORM_IR | Y.FORM_iRR | Y.FORM_RRR,
 Y.OPTIONAL|Y.ALIAS_IRR|Y.IgnoreImmSign|Y.YASEP32_ONLY,
 "Multiply higher halfword (unsigned)");

