/*
  yasep/regression/test_asm.js created by whygee at f-cpu.org
  This file is distributed under terms of the Affero GPL v3 license or later, see http://yasep.org
  created 2007-04-01 from opcode_map.html
  2007-04-04 : moved all the JS stuff to vspsim/test/test_opcodes.js
  2007-04-08 : aliases included and converted
  2007-04-09 : some more cleanup
  2007-04-11 : added various details.
  2007-04-17 : updated for new flags
  2007-11-05 : YASEP rebranding, support of the flags IMM16_5LSB and IMM16_8LSB
  2009-07-10 : adapted for js_list2
  2009-07-28 : Y
  2009-08-10 : new disassembler
  2009-08-23 : it's working again !
  2011-09-08 : moved from benches/test_opcodes.html and turned into an autonomous window.
  2011-09-11 : big changes !
  2012-09-27 : added scan_examples
  2013-07-26 : moved from ASM/test_opcodes to Dev/test_asm / regression/test_asm.js
      inclusion in the regression window, scan_examples moved to regression.js

  This file exercises the assembler and disassembler and searches inconsistencies
*/

test_asm={
  win:null,
  chunks:15, // how many instructions before a page redraw
  HTML:"",
  // start creates other variables

  add_message: function(col,msg){
    test_asm.HTML +='      <span style="background-color:'+col+'">'+(test_asm.msg_number++)+"</span>: "+msg+"\n";
  },

  test_opcode: function(x) {
    var a=' <a id="end_error" name="end_error"> ';
    test_asm.HTML+='  <a class="asm_active" onclick="wa(\'ASM/asm#a?'+x+'\')" href="#!ASM/asm#a?'+x+'">'+x+"</a>\n";
    if (Y.encode_instruction(x,test_asm.ASM)) {
      Y.DISASM(test_asm.ASM.encoded_instruction,test_asm.DISASM);
      if (test_asm.DISASM.instruction != x) {
        // putting the <a> tag here should force the browser to go to the first error in the list
        test_asm.add_message("red",a+"output != input</a>");
        test_asm.errnum++;
      }
    }
    else {
      test_asm.add_message("red",a+"error </a>");
      test_asm.errnum++;
    }
  },

  scan_opcode_table: function() {
    if (test_asm.cur_opcode>=test_asm.max_opcode) { // last opcode scanned ?
      if (test_asm.errnum > 0) {
        test_asm.win.shortmsg(I8N("tcw")+test_asm.errnum+I8N("rs"));
        document.location.href="#end_error";  // focus qui marche
        YGCSS.changeTheme(test_asm.win, "doc_red")
      }
      else {
        test_asm.win.shortmsg(I8N("Ts"));
        YGCSS.changeTheme(test_asm.win, "doc_gryl")
      }
/* Send message here to the regression window that it's finished */
    }
    else {
      test_asm.HTML="";
      var chunk=test_asm.chunks; // display "chunks" <pre> at a time
      while ((chunk > 0) && (test_asm.cur_opcode < test_asm.max_opcode)) {
        chunk--;

        var name=test_asm.sorted_opcodes[test_asm.cur_opcode++], // also gets rid of aliases
            index=Y.table_opcode[name].val,
            instr=Y.opcode_table[index];

        test_asm.HTML+="<hr>"+int2hex(index)+' : <a href="ISM/'+name+'.html">'
               +name+'</a>    "<i>'+instr.description+'"</i>\n';

        // Scan the forms list
        var f=instr.forms;
        var i=1;

        do {
          if (f & i) {
            var j=Y.TableForm[i];
            var k=j.replace(/FORM_/,"");
            var v=' -<a href="#docs/instructions.html#'+k+'">'+j+"</a>";

            var w=Y.TableEncoders[j].ex(instr.flags, name); // random operands
            if (w=="") // no operands so don't add a spacer that will bork the instruction
              w=instr.name;
            else 
              w=instr.name+" "+w;
            test_asm.HTML+=v+"\n";

            test_asm.test_opcode(w);

            if ((i & Y.FORMS_EXTENDABLE)&&((instr.flags & Y.NO_CONDITION)==0))
              test_asm.test_opcode(w+" "+Y.randomCondition());
          }
          i<<=1;
        } while (i <= f);
      } // while chunk>0...
      var new_pre = dcE("pre");
      new_pre.innerHTML=test_asm.HTML;
      test_asm.win.contents_id.firstChild.appendChild(new_pre);

      redraw(test_asm.scan_opcode_table);
    }
  },

  trigger: function(s) { // that's where the actual job is done
    // (re-)initialise important variables
    test_asm.msg_number=0;
    test_asm.errnum=0;
    test_asm.cur_opcode=0;

// erase all (eventual) the previous results
    while ( ( s=test_asm.win.contents_id.firstChild.lastChild)
         ["nodeName"] == "PRE")
      rC(s);

    YGCSS.changeTheme(test_asm.win, "default");  // change the window color
    test_asm.win.shortmsg(I8N("rng"));
    redraw(test_asm.scan_opcode_table);  // start the whole thing
  },

  start: function() {
    test_asm.sorted_opcodes=[];
    test_asm.max_opcode=0;
    test_asm.win= ygwm.new_window( "", null, "none",
       650, Math.ceil((getHeight()*3)/4),
       100, 50, false, true, true, true, false);

    test_asm.win.contents_id.firstChild.innerHTML=import_htmi("regression/test_asm");
    winman.patchInnerLinks(test_asm.win.contents_id);
    ygwm.changeWinTitle(test_asm.win, hiddenText(0,
       getByClass("hiddenDiv","DIV", test_asm.win.contents_id)));

    test_asm.ASM   = new    Y.ASM_context(test_asm.add_message);
    test_asm.DISASM= new Y.DISASM_context(test_asm.add_message);
    test_asm.ASM.YASEP_TYPE=32; // => IMM20 works

    // prepare the sorted list of opcodes
    for (var name in Y.table_opcode) {
      if ((Y.table_opcode[name].forms>0)
      && (typeof Y.opcode_aliases[name]) == "undefined") // check it's not an alias
        test_asm.sorted_opcodes[test_asm.max_opcode++]=name;
    }
    test_asm.sorted_opcodes=test_asm.sorted_opcodes.sort();

    (test_asm.win.trigger=
     test_asm.trigger)();
    return test_asm.win;
  },
}